Attribute VB_Name = "Module1"
Option Explicit

Public Enum BF_FLAGS
   BIF_RETURNONLYFSDIRS = &H1
   BIF_DONTGOBELOWDOMAIN = &H2
   BIF_EDITBOX = &H10
   BIF_NEWDIALOGSTYLE = &H40
   BIF_INCLUDEFILES = &H4000&
End Enum

Public Enum SpecialFolderConstants
   CSIDL_DESKTOP = &H0                 '{desktop}
   CSIDL_INTERNET = &H1                'Internet Explorer (icon on desktop)
   CSIDL_PROGRAMS = &H2                'Start Menu\Programs
   CSIDL_CONTROLS = &H3                'My Computer\Control Panel
   CSIDL_PRINTERS = &H4                'My Computer\Printers
   CSIDL_PERSONAL = &H5                'My Documents
   CSIDL_FAVORITES = &H6               '{user name}\Favorites
   CSIDL_STARTUP = &H7                 'Start Menu\Programs\Startup
   CSIDL_RECENT = &H8                  '{user name}\Recent
   CSIDL_SENDTO = &H9                  '{user name}\SendTo
   CSIDL_BITBUCKET = &HA               '{desktop}\Recycle Bin
   CSIDL_STARTMENU = &HB               '{user name}\Start Menu
   CSIDL_DESKTOPDIRECTORY = &H10       '{user name}\Desktop
   CSIDL_DRIVES = &H11                 'My Computer
   CSIDL_NETWORK = &H12                'Network Neighborhood
   CSIDL_NETHOOD = &H13                '{user name}\nethood
   CSIDL_FONTS = &H14                  'windows\fonts
   CSIDL_TEMPLATES = &H15
   CSIDL_COMMON_STARTMENU = &H16       'All Users\Start Menu
   CSIDL_COMMON_PROGRAMS = &H17        'All Users\Programs
   CSIDL_COMMON_STARTUP = &H18         'All Users\Startup
   CSIDL_COMMON_DESKTOPDIRECTORY = &H19 'All Users\Desktop
   CSIDL_APPDATA = &H1A                '{user name}\Application Data
   CSIDL_PRINTHOOD = &H1B              '{user name}\PrintHood
   CSIDL_LOCAL_APPDATA = &H1C          '{user name}\Local Settings\Application Data (non roaming)
   CSIDL_ALTSTARTUP = &H1D             'non localized startup
   CSIDL_COMMON_ALTSTARTUP = &H1E      'non localized common startup
   CSIDL_COMMON_FAVORITES = &H1F
   CSIDL_INTERNET_CACHE = &H20
   CSIDL_COOKIES = &H21
   CSIDL_HISTORY = &H22
   CSIDL_COMMON_APPDATA = &H23          'All Users\Application Data
   CSIDL_WINDOWS = &H24                 'GetWindowsDirectory()
   CSIDL_SYSTEM = &H25                  'GetSystemDirectory()
   CSIDL_PROGRAM_FILES = &H26           'C:\Program Files
   CSIDL_MYPICTURES = &H27              'C:\Program Files\My Pictures
   CSIDL_PROFILE = &H28                 'USERPROFILE
   CSIDL_SYSTEMX86 = &H29               'x86 system directory on RISC
   CSIDL_PROGRAM_FILESX86 = &H2A        'x86 C:\Program Files on RISC
   CSIDL_PROGRAM_FILES_COMMON = &H2B    'C:\Program Files\Common
   CSIDL_PROGRAM_FILES_COMMONX86 = &H2C 'x86 Program Files\Common on RISC
   CSIDL_COMMON_TEMPLATES = &H2D        'All Users\Templates
   CSIDL_COMMON_DOCUMENTS = &H2E        'All Users\Documents
   CSIDL_COMMON_ADMINTOOLS = &H2F       'All Users\Start Menu\Programs\Administrative Tools
   CSIDL_ADMINTOOLS = &H30              '{user name}\Start Menu\Programs\Administrative Tools
End Enum
Private Type BROWSEINFO  ' Folder Dialog
   hOwner           As Long
   pidlRoot         As Long
   pszDisplayName   As String
   lpszTitle        As String
   ulFlags          As Long
   lpfn             As Long
   lParam           As Long
   iImage           As Long
End Type

Private Declare Function SHBrowseForFolder Lib "Shell32" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Private Declare Function SHSimpleIDListFromPath Lib "Shell32" Alias "#162" (ByVal szPath As String) As Long
Private Declare Function SHILFromPath Lib "Shell32" Alias "#157" (ByVal szPath As String) As Long
Private Declare Function SHILCreateFromPath Lib "Shell32" Alias "#28" (ByVal szPath As String, pidl As Long, ByVal dwAttributes As Long) As Long
'>=w2k
'Private Declare Function SHILCreateFromPath Lib "Shell32" (ByVal szPath As String, pidl As Long, ByVal dwAttributes As Long) As Long

Private Declare Function SHGetPathFromIDList Lib "Shell32" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Const WM_USER = &H400
Const BFFM_INITIALIZED = 1
Const BFFM_SELECTIONCHANGED = 2
Const BFFM_SETSTATUSTEXTA = (WM_USER + 100)
Const BFFM_ENABLEOK As Long = (WM_USER + 101)
Const BFFM_SETSELECTIONA As Long = (WM_USER + 102)
Private Declare Sub CoTaskMemFree Lib "ole32" (ByVal pv As Long)
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As Long) As Long
Private Declare Function SHILClone Lib "Shell32" Alias "#18" (ByVal pidl As Long) As Long
Private Declare Function CoInitialize Lib "OLE32.DLL" (ByVal pvReserved As Long) As Long
Private Declare Sub CoUninitialize Lib "OLE32.DLL" ()

Const MAX_PATH = 260

Dim sCurrentFolder As String

Public Function ShowBFDialog(ByVal hOwner As Long, ByVal sTitle As String, Optional lFlags As BF_FLAGS = BIF_RETURNONLYFSDIRS, Optional vRootFolder As Variant = "", Optional vSelectedFolder As Variant = "") As String
  Dim bi As BROWSEINFO
  Dim pidl As Long
  Dim sPath As String
  
  Call CoInitialize(0)
  With bi
      .hOwner = hOwner
      .ulFlags = lFlags
      .lpszTitle = sTitle
      .pidlRoot = FolderPidl(vRootFolder)
      .lParam = FolderPidl(vSelectedFolder)
      .lpfn = FARPROC(AddressOf BrowseCallbackProc)
  End With
  pidl = SHBrowseForFolder(bi)
  sPath = String$(MAX_PATH, 0)
  If SHGetPathFromIDList(ByVal pidl, ByVal sPath) Then
     ShowBFDialog = Left(sPath, InStr(sPath, Chr$(0)) - 1)
  End If
  CoUninitialize
  Call CoTaskMemFree(pidl)
End Function

Public Function BrowseCallbackProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case uMsg
      Case BFFM_INITIALIZED
           Call SendMessage(hwnd, BFFM_SETSELECTIONA, False, ByVal lParam)
'           Call SendMessage(hwnd, BFFM_ENABLEOK, 0&, ByVal lParam)
      Case BFFM_SELECTIONCHANGED
'You may interact with user when (s)he select a folder
'           Dim path As String, pos As Long
'           path = String$(MAX_PATH, 0)
'           If SHGetPathFromIDList(ByVal wParam, ByVal path) Then
'              pos = InStr(path, Chr$(0))
'              sCurrentFolder = Left(path, pos - 1)
'              Form1.Caption = sCurrentFolder
'           End If
      Case Else
   End Select
End Function

Private Function FARPROC(pfn As Long) As Long
  FARPROC = pfn
End Function

Private Function FolderPidl(ByVal vPath As Variant) As Long
      If IsNumeric(vPath) Then
         FolderPidl = SpecialFolderPidl(vPath)
      Else
         FolderPidl = NormalFolderPidl(vPath)
      End If
End Function

Private Function SpecialFolderPidl(ByVal sfc As SpecialFolderConstants) As Long
   Dim pidl As Long
   SHGetSpecialFolderLocation 0, CLng(sfc), pidl
   SpecialFolderPidl = SHILClone(pidl)
   Call CoTaskMemFree(pidl)
End Function

Private Function NormalFolderPidl(ByVal sPath As String) As Long
'Normalize path
   If Len(sPath) < 4 Then 'Drive
      sPath = Left(sPath, 1) & ":\"
   Else 'Folder
      If Right(sPath, 1) = "\" Then sPath = Left(sPath, Len(sPath) - 1)
   End If
   If IsWindowsNT Then
      NormalFolderPidl = SHSimpleIDListFromPath(StrConv(sPath, vbUnicode))
   Else
      NormalFolderPidl = SHSimpleIDListFromPath(sPath)
   End If
End Function

Private Function IsWindowsNT() As Boolean
   IsWindowsNT = (Environ$("OS") <> "")
End Function

